package consume

import (
	"applet/app/db"
	model2 "applet/app/db/offical/model"
	svc2 "applet/app/svc"
	"applet/app/utils/logx"
	"applet/consume/md"
	md3 "applet/mall/md"
	"applet/mall/svc"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_mq.git/rabbit"
	"encoding/json"
	"errors"
	"fmt"
	"github.com/gin-gonic/gin"
	"github.com/jinzhu/copier"
	"github.com/streadway/amqp"
	"strings"
)

func MallAddSupplyGoodsConsume(queue md.MqQueue) {
	fmt.Println(">>>>>>>>>>>>>>>>>>>>>>>>")
	ch, err := rabbit.Cfg.Pool.GetChannel()
	if err != nil {
		logx.Error(err)
		return
	}
	defer ch.Release()

	//1、将自己绑定到交换机上
	ch.Bind(queue.Name, queue.ExchangeName, queue.RoutKey)
	//2、取出数据进行消费
	ch.Qos(1)
	delivery := ch.Consume(queue.Name, false)

	var res amqp.Delivery
	var ok bool
	for {
		res, ok = <-delivery
		if ok == true {
			fmt.Println(">>>>>>>>>>>>>>>>MallAddSupplyGoodsConsume<<<<<<<<<<<<<<<<<<<<<<<<<")
			err = handleMallAddSupplyGoodsConsume(res.Body)
			if err != nil {
				fmt.Println("*****************err*************************", err)
			}
			_ = res.Ack(true)
		} else {
			panic(errors.New("error getting message"))
		}
	}
	fmt.Println("get msg done")
}

func handleMallAddSupplyGoodsConsume(msgData []byte) error {
	var msg map[string]string
	err := json.Unmarshal(msgData, &msg)
	if err != nil {
		panic(err)
	}

	//解析mq中queue的数据结构体
	var pushStuct struct {
		Mid      string `json:"mid"`
		Affected string `json:"affected"`
	}
	err = json.Unmarshal([]byte(msg["data"]), &pushStuct)
	if err != nil {
		panic(err)
	}
	//设置masterId
	var c = &gin.Context{}
	if pushStuct.Mid == "123456" {
		return nil
	}
	c.Set("mid", pushStuct.Mid)

	//查找 MallAddSupplyGoods
	var mm model2.MallAddSupplyGoods
	get, err := db.Db.Where("id=?", pushStuct.Affected).Get(&mm)
	if err != nil {
		panic(err)
	}
	if !get {
		return errors.New("未查询到记录：：：" + pushStuct.Affected)
	}
	var t struct {
		GoodsInfo []*md3.OfficialGoods `json:"goods_info"`
		md3.OfficialGoodsConditions
	}

	err = json.Unmarshal([]byte(mm.Data), &t)
	if err != nil {
		panic(err)
	}
	var conditions md3.OfficialGoodsConditions
	conditions.CategoryId = t.CategoryId
	conditions.AddPriceBase = t.AddPriceBase
	conditions.AddPriceNum = t.AddPriceNum
	conditions.AddPriceType = t.AddPriceType
	conditions.NumType = t.NumType
	engine := svc2.MasterDb(c)
	for _, goods := range t.GoodsInfo {
		var b2cGoods md3.OfficialGoods
		copier.Copy(&b2cGoods, goods)
		ex := strings.Split(b2cGoods.Price, "-")
		b2cGoods.Price = ex[0]
		err1 := svc.AddOfficialGoods(c, engine, &b2cGoods, &conditions)
		if err1 != nil {
			return err1
		}
	}

	db.Db.Where("id = ?", pushStuct.Affected).Delete(model2.MallAddSupplyGoods{})
	return nil
}
